﻿var mongo = require("../mongo");
var book_controller = require("../controllers/book");
////////////////////////////////////////////////////////////////////
var Master_books = function (number, key) {
    this.number = number;
    this.key = key;
    this.keys = [];
}
Master_books.schema = {
    number: Number,
    key: String,
    keys: Array
}
Master_books.model_name = "Master_books";
Master_books.model = mongo.load_model(Master_books.model_name, Master_books.schema);
Master_books.prototype.upsert = function (substitution, after) {
    mongo.upsert(Master_books, {key: this.key}, { $set: substitution}, after);
}
//name author publisher
Master_books.maps = [new Object(), new Object(), new Object()];
Master_books.render = function (req, res) {
    if (req.query.search == undefined) {
        render2(res, Master_book.list_map);
        return;
    }
    var c = req.query.search.charAt(0);
    if ('0' <= c && c <= '9') {
        Master_book.read({ links: { "$size": c - '0' } }, function (err, data) {
            render2(res, data.objs);
        });
    }
    else {
        Master_book.read({ key: new RegExp(req.query.search) }, function (err, data) {
            render2(res, data.objs);
        });
    }
}
function render2(res, book_array) {
    var master_books_str = "";
    var num_map = new Object();
    for (var i = 0, n = 0; i < 10; i++) {
        var n2 = Math.floor(Math.random() * 100000) % book_array.length;
        if (num_map[n2] == true) {
            if (n == 100) break;
            i--;
            n++;
            continue;
        }
        num_map[n2] = true;
        var book = book_array[n2];
        var bk = Book.map[book.links[0]];
        if (bk == undefined) {
            i--;
            continue;
        }
        master_books_str += "<tr>";
        master_books_str += "<td>";
        master_books_str += "<a href=\"/book_view?key=" + escape(book.key) + "\">";
        master_books_str += bk.name;
        master_books_str += "</a>";
        master_books_str += "</td>";
        master_books_str += "</tr>";
    }
    res.render("book_views", { title: "book_views", master_books: master_books_str });
}
exports.Master_books = Master_books;
/////////////////////////////////////////////////////////////////////
var Master_book = function (key) {
    this.key = key;
    this.links = [];
}
Master_book.schema = {
    key: String,
    links: Array,
}
Master_book.model_name = "Master_book";
Master_book.model = mongo.load_model(Master_book.model_name, Master_book.schema);
Master_book.map = new Object();
Master_book.list_map = [];
Master_book.prototype.save = function (after) {
    mongo.save(Master_book, this, after);
}
Master_book.prototype.upsert = function (substitution, after) {
    mongo.upsert(Master_book, { key: this.key }, { $set: substitution }, after);
}
Master_book.prototype.save = function (after) {
    mongo.save(Master_book, this, after);
}
Master_book.prototype.split = function () {
    for (var i = 0; i < this.links.length; i++) {
        for (var j = i + 1; j < this.links.length; j++) {
            if (this.links[i].domain() == this.links[j].domain()) {
                var b1 = Book.map[this.links[i]], b2 = Book.map[this.links[j]];
                if (b1.ebook == b2.ebook) {
                    //now programing
                }
            }
        }
    }
}
Master_book.prototype.render = function (res) {
    /*now coding*/
    var master_book = this;
    var main_link = master_book.links[0];
    var main_book = Book.map[main_link];
    var books_str = "";
    var ebooks_str = "";
    var recommends_str = "";
    var recommends = [];
    for (var i = 0; i < master_book.links.length; i++) {
        var link = master_book.links[i];
        var book = Book.map[link];
        if (book == undefined) continue;
        if (book.ebook == true) {
            ebooks_str += "<td>";
            ebooks_str += "<a href=\"http://" + book.address + "\">";
            ebooks_str += book.address.domain();
            ebooks_str += "</a>"
            ebooks_str += "</td>";
        }
        else {
            books_str += "<td>";
            books_str += "<a href=\"http://" + book.address + "\">";
            books_str += book.address.domain();
            books_str += "</a>"
            books_str += "</td>";
        }
        for (var j = 0; j < book.links.length; j++) {
            recommends.push(book.links[j]);
        }
    }
    for (var i = 0, n = 0; i < 10; i++) {
        var n2 = Math.floor(Math.random() * 1000) % recommends.length;
        if (recommends[n2] === undefined) {
            if (n == 100) break;
            i--;
            n++;
            continue;
        }
        var book = Book.map[recommends[n2]];
        if (book == undefined || book.name === undefined || book.name == null) continue;
        recommends[n2] = undefined;
        recommends_str += "<td>";
        recommends_str += "<a href=\"/book_view?key=" + escape(book.key) + "\">";
        recommends_str += book.name;
        recommends_str += "</a>";
        recommends_str += "</td>";
    }
    res.render("book_view", { title: main_book.name, name: main_book.name, image_address: main_book.image_address, shop: main_link.domain(), author: main_book.author, publisher: main_book.publisher, price: main_book.price, free: main_book.free?"":"disabled", buy_address: main_book.address , preview: main_book.preview, books: books_str, ebooks: ebooks_str, recommend: recommends_str});
}
//after(err, data.objs)
Master_book.read = function (condition, after) {
    mongo.read(Master_book, condition, after);
}
Master_book.read_all = function () {
    Master_book.read("", function (err, data) {
        for (var i = 0; i < data.objs.length; i++) {
            var obj = data.objs[i];
            Master_book.push_map(obj);
        }
    });
}
Master_book.push_map = function (master_book) {
    if (Master_book[master_book.key] !== undefined) return;
    Master_book.map[master_book.key] = master_book;
    Master_book.list_map.push(master_book);
}
Master_book.read_all();
exports.Master_book = Master_book;
/////////////////////////////////////////////////////////////////////
var Book = function (address) {
    this.key = null;
    this.address = address;
    this.name = null;
    this.author = null;
    this.publisher = null;
    this.publish_date = null;
    this.image_address = null;
    this.price = null;
    this.preview = null;
    this.free = false;
    this.ebook = false;
    this.links = [];
    this.checked = false;
    this.listed = false;
    this.shared = false;
    this.errored = false;
}
Book.schema = {
    key: String,
    address: String,
    name: String,
    genre: String,
    author: String,
    publisher: String,
    links: Array,
    image_address: String,
    price: String,
    preview: String,
    free: Boolean,
    ebook: Boolean,
    checked: Boolean,
    shared: Boolean,
    listed: Boolean,
    errored: Boolean
};
Book.model_name = "Book";
Book.model = mongo.load_model(Book.model_name, Book.schema);
Book.map = new Object();
Book.precede = ["booklive", "bookweb"];
Book.displays = ["booklive", "honto", "bookweb", "amazon"];
Book.checks = [];
Book.lists = [];
Book.shares = [];
Book.prototype.save = function (after) {
    mongo.save(Book, this, after);
}
Book.prototype.upsert = function (substitution, after) {
    substitution.address = this.address;
    mongo.upsert(Book, { address: this.address }, { $set: substitution }, after);
}
Book.prototype.load_map = function () {
    var book = this;
    if (Book.map[book.address] !== undefined) return;
    this.upsert({checked: false, shared: false}, function (err) {        
        Book.map[book.address] = book;
        Book.checks.push(book);
    });
}
Book.prototype.load_list = function () {
    this.listed = true;
    var book = this;
    if (Book.map[book.address] !== undefined) return;
    this.upsert({listed: true}, function (err) {
        Book.map[book.address] = book;
        Book.lists.push(book.address);
    });
}
Book.prototype.check = function () {
    this.checked = true;
    var book = this;
    this.upsert({ checked: true, name: this.name, author: this.author, links: this.links, image_address: this.image_address, price: this.price, preview: this.preview, ebook: this.ebook, free: this.free, errored: false }, function (err) {
        Book.map[book.address] = book;
        book.errored = true;
        Book.checks.splice(Book.checks.indexOf(book), 1);
        for (var i = 0; i < book.links.length; i++) {
            var b = new Book(book.links[i]);
            b.load_map();
        }
        if (book.shared == false) Book.shares.push(book);
    });
}
Book.prototype.error = function () {
    this.checked = false;
    this.errored = true;
    var book = this;
    this.upsert({ checked: false, errored: this.errored}, function (err) {
        Book.checks.splice(Book.checks.indexOf(book), 1);
        Book.checks.push(book);
    });
}
Book.prototype.set_key = function () {
    var key = get_author(this.author) + "@" + get_name(this.name);
    this.key = key;
    return key;
}
function get_name(name) {
    var name;
    var number;
    var str = "";
    var i = 0;
    for (; i < name.length; i++) {
        var c = name.charCodeAt(i);
        c = String.convert_character(c);
        if (String.is_symbol(c)) break;
        str += String.fromCharCode(c);
    }
    for (; i < name.length; i++) {
        var c = name.charCodeAt(i);
        c = String.convert_character(c);
        if (String.is_number(c) || c == 0x4E0A/*上*/ || c == 0x4E3D/*中*/ || c == 0x4E0B/*下*/ || c == 0x524D/*前*/ || c == 0x5F8C/*後*/) {
            str += "#";
            for (; i < name.length; i++) {
                var c = name.charCodeAt(i);
                c = String.convert_character(c);
                if (String.is_number(c)) str += String.fromCharCode(c);
                else if (c == 0x4E0A/*上*/ || c == 0x524D/*前*/) str += "1";
                else if (c == 0x4E3D/*中*/) str += "2";
                else if (c == 0x4E0B/*下*/ || c == 0x5F8C/*後*/) str += "3";
                else break;
            }
        }
    }
    return str;
}
function get_author(author) {
    var cs = [];
    for (var i = 0; i < author.length; i++) {
        var c = author.charCodeAt(i);
        c = String.convert_character(c);
        if (String.is_symbol(c)) continue;
        cs.push(c);
    }
    var str = "";
    for (var i = 0; i < cs.length; i++) {
        for (var j = i + 1; j < cs.length; j++) {
            if (cs[i] > cs[j]) {
                var cs_i = cs[i];
                cs[i] = cs[j];
                cs[j] = cs_i;
            }
        }
        str += String.fromCharCode(cs[i]);
    }
    return str;
}
Book.prototype.share = function () {
    this.shared = true;
    var key = this.set_key();
    var book = this;
    this.upsert({shared: this.shared, key: this.key}, function (err) {
        if (Master_book.map[key] === undefined) {
            Master_book.push_map(new Master_book(key));
        }
        var master_book = Master_book.map[key];
        var n = master_book.links.indexOf(book.address);
        if (n != -1) {
            Book.shares.splice(Book.shares.indexOf(book), 1);
            return;
        }
        master_book.links.push(book.address);
        master_book.upsert({links: master_book.links}, function (err) {
            Book.shares.splice(Book.shares.indexOf(book), 1);
        });
    });
}
Book.prototype.to_string = function () {
    var str = "key:" + this.key + "<br>" + "name:" + this.name + "<br>" + "address:" + this.address + "<br>" + "author:" + this.author + "<br>" + "ebook:" + this.ebook + "<br>"
    + "price:" + this.price + "<br>" + "preview:" + this.preview + "<br>" + "image_address:" + this.image_address + "<br>" + "free:" + this.free + "<br>" + "publisher:" + this.publisher + "<br>";
    for (var i = 0; i < this.links.length; i++) {
        str += "link" + i + ":" + this.links[i] + "<br>";
    }
    return str;
}
//after = function(err, data.objs)
Book.read = function (condition, after) {
    mongo.read(Book, condition, after);
}
Book.read_all = function () {
    mongo.read(Book, {}, function (err, data) {
        for (var i = 0; i < data.objs.length; i++) {
            var obj = data.objs[i];
            Book.map[obj.address] = obj;
            if (obj.listed == true) {
                Book.lists.push(obj.address);
            }
            else if (obj.checked == false) {
                Book.checks.push(obj);
            }
            else if (obj.shared == false) Book.shares.push(obj);
        }
    });
}
Book.read_list = function () {
}
//after = funtion(err, obj)
Book.read_one = function (condtion, after) {
    mongo.read_one(Book, condtion, after);
}
Book.read_all();
var n_ch = 0;
setInterval(function () {
    if (Book.checks.length == 0) return;
    if (b == Book.checks[0]) {
        n_ch++;
        if (n_ch % 5 != 0) return;
    }
    else b = Book.checks[0];
    book_controller.get_book_info(Book.checks[0]);
}, 3000);
var b;
setInterval(function () {
    if (Book.checks.length == 0) return;
    if (b == Book.checks[0]) b.error();
}, 60000);
setInterval(function () {
    if (Book.shares.length == 0) return;
    Book.shares[0].share();
}, 1000);
var n_l = 0;
setInterval(function () {
    if (Book.lists.length == 0) return;
    book_controller.get_book_list(Book.lists[n_l % Book.lists.length]);
    n_l++;
}, 10000);
exports.Book = Book;